VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Form1"
   ClientHeight    =   5370
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6780
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5370
   ScaleWidth      =   6780
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdShowAllSets 
      Caption         =   "Show All Parameter Sets"
      Height          =   495
      Left            =   240
      TabIndex        =   5
      Top             =   1800
      Width           =   2535
   End
   Begin VB.CommandButton cmdSendSMS 
      Caption         =   "Send SMS"
      Height          =   495
      Left            =   3360
      TabIndex        =   2
      Top             =   2880
      Width           =   3135
   End
   Begin VB.TextBox txtMessage 
      Height          =   1935
      Left            =   3360
      MaxLength       =   160
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "Main.frx":0000
      Top             =   840
      Width           =   3135
   End
   Begin VB.TextBox txtNumber 
      Height          =   375
      Left            =   3360
      TabIndex        =   0
      Top             =   360
      Width           =   3135
   End
   Begin VB.CommandButton cmdShowSet1 
      Caption         =   "Show Parameter Set 1"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   1080
      Width           =   2535
   End
   Begin VB.CommandButton cmdGetSets 
      Caption         =   "Get Parameter Sets"
      Height          =   495
      Left            =   240
      TabIndex        =   3
      Top             =   360
      Width           =   2535
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private smsObj As NokiaCLMessaging.ShortMsgAdapter
Private smsMemObj As NokiaCLMessaging.IMemory


Private Function GetNumberOfSets() As Byte
    Dim paramSets As Byte
    paramSets = 0
    
    On Error GoTo ErrorTrap
    Call smsMemObj.GetParameterSets(paramSets)
    GetNumberOfSets = paramSets
    Exit Function

ErrorTrap:
    MsgBox "Source: " & Err.Source & Chr$(10) _
    & "ErrorDescription: " & Err.Description _
    & Chr$(10) & "HelpContext: " & Err.HelpContext, _
    vbExclamation, "Error"
End Function

Private Function GetParameterSet(ByVal Index As Integer) As IGSMParameters
    On Error GoTo ErrorTrap
    Dim parameterEntry As IGSMParameters
    Set parameterEntry = smsMemObj.GetParameters(PARAMETERS_TYPE_GSM, Index)
    Set GetParameterSet = parameterEntry
    Exit Function
    
ErrorTrap:
    MsgBox "Source: " & Err.Source & Chr$(10) _
    & "ErrorDescription: " & Err.Description _
    & Chr$(10) & "HelpContext: " & Err.HelpContext, _
    vbExclamation, "Error"
End Function

Private Function GetDataCodingSchemeText(ByVal DataCodingScheme As Byte) As String
    Dim Text As String
    Select Case DataCodingScheme
        Case 0: Text = "Default alphabet"
        Case 8: Text = "Unicode"
        Case 240: Text = "Class 0 7-bit alphabet"
        Case 241: Text = "Class 1 7-bit alphabet"
        Case 242: Text = "Class 2 7-bit alphabet"
        Case 243: Text = "Class 3 7-bit alphabet"
        Case 244: Text = "Class 0 8-bit alphabet"
        Case 245: Text = "Class 1 8-bit alphabet"
        Case 246: Text = "Class 2 8-bit alphabet"
        Case 247: Text = "Class 3 8-bit alphabet"
        Case Else: Text = "Unknown"
    End Select
    GetDataCodingSchemeText = Text
End Function

Private Function GetProtocolIDText(ByVal ProtocolID As Byte) As String
    Dim Text As String
    Select Case ProtocolID
        Case 0: Text = "Text"
        Case 3: Text = "Fax" 'Group 3 telefax
        Case 38: Text = "Pager" 'National paging system
        Case 50: Text = "E-Mail" 'Internet Electronic Mail
        Case Else: Text = "Unknown"
    End Select
    GetProtocolIDText = Text
End Function

Private Function GetTimePeriodString(ByVal Period As Date) As String
    Dim Text As String
    Dim h As String
    Dim m As String
    h = Hour(Period)
    m = Minute(Period)
    If h <> "0" And m <> "0" Then
        Text = h & " hours, " & m & " minutes"
    ElseIf h = 0 And m <> 0 Then
        Text = m & " minutes"
    ElseIf h <> "0" And m = 0 Then
        Text = h & " hours"
    End If
    GetTimePeriodString = Text
End Function

Private Function GetRelativeValidityText(ByVal value As Byte) As String
    Dim total As Date
    Dim h As String
    Dim m As String
    Dim Text As String
    Select Case value
        Case 0 To 143
            '(value+1)*5 minutes
            total = TimeSerial(0, (value + 1) * 5, 0)
            Text = GetTimePeriodString(total)
        Case 144 To 166
            '(value-143)*30 minutes + 12 hours
            total = TimeSerial(12, (value - 143) * 30, 0)
            Text = GetTimePeriodString(total)
        Case 167
            Text = "24 hours" 'can't use TimeSerial here because it would wrap back to zero at midnight.
        Case 168 To 196
            '(value-166)*1 day
            Text = CStr(value - 166) & " days"
        Case 197 To 255
            '(value-192)*1 week
            Text = CStr(value - 192) & " weeks"
        Case Else: Text = "Unknown (" & CStr(value) & ")"
    End Select
    GetRelativeValidityText = Text
End Function

Private Sub cmdGetSets_Click()
    Call MsgBox("Number of sets: " & CStr(GetNumberOfSets))
End Sub

Private Sub cmdShowAllSets_Click()
    Dim I As Integer
    For I = 1 To GetNumberOfSets
        Dim params As IGSMParameters
        Set params = GetParameterSet(I)
        Dim info As String
    
        If Not params Is Nothing Then
            With params
                info = _
                    "ParameterSetName: " & .ParameterSetName & vbCrLf & _
                    "DataCodingScheme: " & GetDataCodingSchemeText(.DataCodingScheme) & vbCrLf & _
                    "ProtocolID: " & GetProtocolIDText(.ProtocolID) & vbCrLf & _
                    "ServiceCenterAddress: " & .ServiceCenterAddress & vbCrLf & _
                    "ValidityPeriodRelative: " & GetRelativeValidityText(.ValidityPeriodRelative)
            End With
        Call MsgBox(info, vbOKOnly, "Parameter Set " + CStr(I))
        End If
    Next
End Sub

Private Sub cmdShowSet1_Click()
    Dim params As IGSMParameters
    Set params = GetParameterSet(1)
    Dim info As String
    
    If Not params Is Nothing Then
        With params
            info = _
                "ParameterSetName: " & .ParameterSetName & vbCrLf & _
                "DataCodingScheme: " & GetDataCodingSchemeText(.DataCodingScheme) & vbCrLf & _
                "ProtocolID: " & GetProtocolIDText(.ProtocolID) & vbCrLf & _
                "ServiceCenterAddress: " & .ServiceCenterAddress & vbCrLf & _
                "ValidityPeriodRelative: " & GetRelativeValidityText(.ValidityPeriodRelative)
        End With
    Call MsgBox(info, vbOKOnly, "Parameter Set 1")
    End If
End Sub

Private Sub cmdSendSMS_Click()
    If Not SendSMS(txtNumber.Text, txtMessage.Text) Then
        Call MsgBox("SMS send failed.", vbOKOnly, "SMS Error")
    End If
End Sub

Private Function SendSMS(ByVal Number As String, ByVal Message As String) As Boolean
    SendSMS = False
    On Error GoTo ErrorTrap
    
    'Get data of first parameter set, mostly the right one
    Dim params As IGSMParameters
    Set params = GetParameterSet(1)
    
    If params Is Nothing Then Exit Function
    
    Dim submitObj As NokiaCLMessaging.IGSMSubmit
    Dim smsEntry As NokiaCLMessaging.ShortMessageItem
    
    'Create new short message
    Set smsEntry = New ShortMessageItem
    smsEntry.Type = SHORTMESSAGE_TYPE_GSM_SUBMIT
    Set submitObj = smsEntry.TypeProperties

    submitObj.Message = Message
    submitObj.DestinationAddress = Number
    submitObj.ServiceCenterAddress = params.ServiceCenterAddress
    submitObj.ProtocolID = params.ProtocolID
    submitObj.DataCodingScheme = params.DataCodingScheme
    submitObj.ValidityPeriodRelative = params.ValidityPeriodRelative

    'Send message
    Call smsObj.SendSMS(SHORTMESSAGE_ROUTE_TYPE_ANY, submitObj)

    SendSMS = True
    Exit Function
    
ErrorTrap:
    MsgBox "Source: " & Err.Source & Chr$(10) _
    & "ErrorDescription: " & Err.Description _
    & Chr$(10) & "HelpContext: " & Err.HelpContext, _
    vbExclamation, "Error"
End Function

Private Sub Form_Load()
    Set smsObj = New NokiaCLMessaging.ShortMsgAdapter
    Set smsMemObj = smsObj
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set smsObj = Nothing
End Sub


